// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Opakovac.h"
#include "MainFrm.h"
#include "Best.h"
#include "Rekord.h"

#include <mmsystem.h>
#pragma comment (lib,"winmm.lib")

const POINT g_pts[4] =
{
	{184, 180}, {185, 304}, {309, 303}, {308, 179},
};


UINT G_Intro( LPVOID pParam ) 
{
	CMainFrame *dl = (CMainFrame *) pParam;

	dl->m_playing = true;

	dl->LightButton(0);
	dl->LightButton(1);
	dl->LightButton(2);
	dl->LightButton(3);

	dl->m_playing = false;

	return 0;
}

UINT G_Melody( LPVOID pParam ) 
{
//	srand((unsigned)time( NULL ));
	CMainFrame *dl = (CMainFrame *) pParam;

	dl->m_playing = true;

	Sleep(800);


	for (int i = 0; i < dl->m_valid; i++)
		dl->LightButton(dl->m_melody[i]);

	dl->m_playing = false;

	return 0;
}

UINT G_Outro( LPVOID pParam ) 
{
//	srand((unsigned)time( NULL ));
	CMainFrame *dl = (CMainFrame *) pParam;

	dl->m_playing = true;

	dl->m_tmr2 = 0;
	
	PlaySound("BZZZ", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);

	Sleep(500);
	
	dl->m_ingame = false;

	int max;
	if (dl->m_hid == 0)
		max = AfxGetApp()->GetProfileInt("Rekord", "tonu 1", 0);
	else
		max = AfxGetApp()->GetProfileInt("Rekord", "tonu 2", 0);

	if (dl->m_valid - 1 > max) {
		max = dl->m_valid - 1;
		CRekord dlg(dl->m_hid);
		dlg.DoModal();
		if (dl->m_hid == 0)
			AfxGetApp()->WriteProfileInt("Rekord", "tonu 1", max);
		else
			AfxGetApp()->WriteProfileInt("Rekord", "tonu 2", max);

		CBest best;
		best.DoModal();
	}


	dl->OnUpdate(NULL);


	int ID;
	if (dl->m_valid >= MAX_LIMIT2) ID = 1;
	else ID = 0;

	for (int i = 0; i < 8; i++)
		dl->LightButton(ID);

	dl->m_playing = false;

	return 0;
}


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_ERASEBKGND()
	ON_WM_CHAR()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	ON_COMMAND(ID_HRA_NEJLEPVSLEDKY, OnHraNejlepvsledky)
	ON_COMMAND(ID_HRA_NOV, OnHraNov)
	ON_COMMAND(ID_HRA_NOV2, OnHraNov2)
	ON_COMMAND(ID_HRA_OPAKUJ, OnHraOpakuj)
	ON_COMMAND(ID_HRA_POSLEDN, OnHraPosledn)
	ON_UPDATE_COMMAND_UI(ID_HRA_NEJLEPVSLEDKY, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_HRA_NOV, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_HRA_NOV2, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_HRA_OPAKUJ, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_HRA_POSLEDN, OnUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_valid  = 0;
	m_tmr1   = 0;
	m_ingame = false;
}

CMainFrame::~CMainFrame()
{
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (CFrameWnd::PreCreateWindow(cs) == 0) return FALSE;

	cs.cx = 512;
	cs.cy = 512;
	cs.style &= ~(WS_SIZEBOX | WS_MAXIMIZEBOX);
	
	return TRUE;
}

void CMainFrame::Init()
{
	CRect r1, r2;
	GetWindowRect(r1);
	GetClientRect(r2);
	int w = 512 - r2.Width() + r1.Width(),
		 h = 512 - r2.Height() + r1.Height();

	SetWindowPos(NULL, 0, 0, w, h, SWP_NOMOVE | SWP_NOZORDER);


	m_plocha.LoadBitmap(IDB_PLOCHA);
	m_svetlo.LoadBitmap(IDB_SVETLO);
	m_svetlom.LoadBitmap(IDB_SVETLOM);
	m_temp.LoadBitmap(IDB_TMP);

	SetTimer(0, 100, NULL);

	OnUpdate(NULL);
}

BOOL CMainFrame::OnEraseBkgnd(CDC* pDC) 
{
	CFrameWnd::OnEraseBkgnd(pDC);

	CRect rect;
	GetWindowRect(&rect);
	rect.bottom -= rect.top; rect.top = 0;
	rect.right -= rect.left; rect.left = 0;

	pDC->FillSolidRect(rect, RGB(255,0,0));

	CDC  dc;
	dc.CreateCompatibleDC(pDC);
	CBitmap * p_dc = dc.SelectObject(&m_plocha);
	pDC->BitBlt(0, 0, 600, 655, &dc, 0, 0, SRCCOPY);
	dc.SelectObject(m_plocha);

	return TRUE;
}

void CMainFrame::LightButton(int ID)
{
	CDC *dc = GetDC();
	CDC cdc;
	CDC cdc2;
	cdc.CreateCompatibleDC(dc);
	cdc2.CreateCompatibleDC(dc);
	CBitmap *p_cdc = (CBitmap*)cdc.SelectObject(m_temp);
	CBitmap *p_cdc2 = (CBitmap*)cdc2.SelectObject(m_plocha);
	cdc.BitBlt(0, 0, 32, 32, &cdc2,  g_pts[ID].x, g_pts[ID].y, SRCCOPY);
	cdc2.SelectObject(m_svetlom);
	cdc.BitBlt(0, 0, 32, 32, &cdc2, 0, 0, SRCPAINT);
	cdc2.SelectObject(m_svetlo);
	cdc.BitBlt(0, 0, 32, 32, &cdc2,  0, 0, SRCAND);
	dc->BitBlt(g_pts[ID].x, g_pts[ID].y, 32, 32, &cdc,  0, 0, SRCCOPY);

	CString s;
	s.Format("BEEP%d", ID+1);
	PlaySound(s, AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);

	cdc.SelectObject(m_plocha);
	dc->BitBlt(g_pts[ID].x, g_pts[ID].y, 32, 32, &cdc,  g_pts[ID].x, g_pts[ID].y, SRCCOPY);

	ReleaseDC(dc);
}

void CMainFrame::Pressed(int ID)
{
	if (m_playing) return;

	if (m_ingame)
		AddGame(ID);
	else {
		switch (ID) {
		case 3:
			OnHraPosledn();
			break;
		case 2:
			OnHraOpakuj();
			break;
		case 0:
			OnHraNov();
			break;
		case 1:
			OnHraNov2();
			break;

		}
	}
}



void CMainFrame::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (m_playing) return;

	switch (_toupper(nChar)) {
	case 'R':  // R
	case  'Q':  // Q
		Pressed(0);
		break;
	case 'T':  // T
	case 'P':  // P
		Pressed(3);
		break;
	case 'F':  // F
	case 'C':  // C
		Pressed(1);
		break;
	case 'G':  // G
	case 'M':  // M
		Pressed(2);
		break;
	}
	
	CFrameWnd::OnChar(nChar, nRepCnt, nFlags);
}

void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	
	CFrameWnd::OnLButtonDown(nFlags, point);
}

void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	
	CFrameWnd::OnLButtonUp(nFlags, point);
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	if (m_playing) return;

	if (m_ingame) {
		m_tmr1 = 0;
		if (++m_tmr2 == 30) {
			m_tmr2 = 0;
			EndGame();
		}
	}
	else {
		if (++m_tmr1 == 90) {
			PlayIntro();
			m_tmr1 = 0;
		}
	}
	
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::PlayIntro()
{
	AfxBeginThread(G_Intro, this);
}

void CMainFrame::OnHraNejlepvsledky() 
{
	CBest dlg;
	dlg.DoModal();
}

void CMainFrame::OnHraNov() 
{
	StartGame(0, true);
}

void CMainFrame::OnHraNov2() 
{
	StartGame(1, true);
}

void CMainFrame::OnHraOpakuj() 
{
	if (m_valid != 0) 
		PlayMelody();
	else
		PlaySound("BZZZ", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
}

void CMainFrame::OnHraPosledn() 
{
	m_tmr1 = 0;
	if (m_valid != 0) 
		StartGame(m_hid, false);
	else
		PlaySound("BZZZ", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
}

void CMainFrame::AddGame(int ID)
{
	if (m_player == m_valid && m_hid == 1) {
		m_melody[m_player] = ID;
		LightButton(ID);
		m_valid++;
		AddToneToMelody();
		return;
	}

	if (m_melody[m_player] != ID) {
		EndGame();
		return;
	}

	LightButton(ID);

	m_player++;
	if (m_player - m_hid == m_valid)
		AddToneToMelody();
	m_tmr2 = 0;

}

void CMainFrame::StartGame(int hid, bool mazat)
{
	if (mazat)
		for (int i = 0; i < MAX_TONES; i++)
			m_melody[i] = rand()%4;
	m_hid    = hid;
	m_ingame = true;
	m_valid  = 0;

	AddToneToMelody();

	OnUpdate(NULL);
}

void CMainFrame::EndGame()
{
	m_tmr2 = 0;
	AfxBeginThread(G_Outro, this);
}

void CMainFrame::PlayMelody()
{
	AfxBeginThread(G_Melody, this);
}

void CMainFrame::AddToneToMelody()
{
	if (++m_valid > MAX_TONES-5) {
		MessageBox("Gratuluji, s takovm vkonem nikdo nepotal\na hra ji nem kapacitu na dal tny melodie.\nTakov pam se jen tak nevid.");
		EndGame();
		return;
	}
	m_player = 0;
	PlayMelody();
	m_tmr2 = 0;
}

void CMainFrame::OnUpdate(CCmdUI* pCmdUI) 
{
	CMenu *m = GetMenu();
	if (m_ingame) {
		m->EnableMenuItem(ID_HRA_NEJLEPVSLEDKY ,MF_BYCOMMAND | MF_GRAYED);
		m->EnableMenuItem(ID_HRA_NOV ,MF_BYCOMMAND | MF_GRAYED);
		m->EnableMenuItem(ID_HRA_NOV2 ,MF_BYCOMMAND | MF_GRAYED);
		m->EnableMenuItem(ID_HRA_OPAKUJ ,MF_BYCOMMAND | MF_GRAYED);
		m->EnableMenuItem(ID_HRA_POSLEDN ,MF_BYCOMMAND | MF_GRAYED);
	}
	else {
		m->EnableMenuItem(ID_HRA_NEJLEPVSLEDKY ,MF_BYCOMMAND | MF_ENABLED);
		m->EnableMenuItem(ID_HRA_NOV ,MF_BYCOMMAND | MF_ENABLED);
		m->EnableMenuItem(ID_HRA_NOV2 ,MF_BYCOMMAND | MF_ENABLED);
		if (m_valid != 0) {
			m->EnableMenuItem(ID_HRA_OPAKUJ ,MF_BYCOMMAND | MF_ENABLED);
			m->EnableMenuItem(ID_HRA_POSLEDN ,MF_BYCOMMAND | MF_ENABLED);
		}
		else {
			m->EnableMenuItem(ID_HRA_OPAKUJ ,MF_BYCOMMAND | MF_GRAYED);
			m->EnableMenuItem(ID_HRA_POSLEDN ,MF_BYCOMMAND | MF_GRAYED);
		}
	}
}
